<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Report_lib {
	
	function __construct()
	{
		// defined report types
		define('REPORT_TIME_SUMMARY', 'TS');
		define('REPORT_TIME_DETAIL', 'TD');
		define('REPORT_TASK_SUMMARY', 'AS');
		define('REPORT_TASK_DETAIL', 'AD');
		define('REPORT_INVOICE_SUMMARY', 'IS');
		define('REPORT_INVOICE_DETAIL', 'ID');
		define('REPORT_INVOICE_AGING', 'IA');
		define('REPORT_INVOICE_OUTSTANDING', 'IO');
		define('REPORT_INVOICE_UNINVOICED', 'IU');
		define('REPORT_INVOICE_UNINVOICED_HOURS_DETAIL', 'UO');
		define('REPORT_INVOICE_UNINVOICED_EXPENSE_DETAIL', 'UE');
		define('REPORT_BUDGET', 'BU');
		define('REPORT_BUDGET_DETAIL', 'BD');
		define('REPORT_EXPENSE_SUMMARY', 'ES');
		define('REPORT_EXPENSE_DETAIL', 'ED');

		// defineed fields
		define('REP_PERIOD', 'DA');
		define('REP_CLIENT', 'CL');
		define('REP_PROJECT', 'PR');
		define('REP_TASK_TYPE', 'TT');
		define('REP_TASK_TYPE_ID', 'TI');
		define('REP_EXPENSE_TYPE', 'ET');
		define('REP_EXPENSE_QUANTITY', 'EQ');
		define('REP_UNIT_PRICE', 'EP');
		define('REP_EXPENSE_AMOUNT','XA');
		define('REP_USER', 'US');
		define('REP_HOURS', 'TH');
		define('REP_TIMESHEET_HOURS', 'SH');
		define('REP_BILLABLE_HOURS', 'BH');
		define('REP_NON_BILLABLE_HOURS', 'NH');
		define('REP_BILLABLE_AMOUNT', 'BA');
		define('REP_INVOICED_HOURS', 'IH');
		define('REP_UN_INVOICED_HOURS' , 'UH');
		define('REP_TASK', 'TA');
		define('REP_PROJECT_TASK', 'PK');
		define('REP_START_AND_END_TIME' , 'TE');
		define('REP_TIME_NOTES', 'TN');
		define('REP_RATE', 'RA');
		
		define('REP_STATUS', 'SS');
		define('REP_TASK_STATUS', 'TKS');
		define('REP_STATUS_BGCOLOR', 'SB');
		define('REP_STATUS_TEXT_COLOR', 'SX');
		define('REP_START', 'ST');
		define('REP_FINISH', 'FH');
		define('REP_DURATION', 'DU');
		define('REP_TS_ESTIMATED_HOURS', 'ER');
		define('REP_PERCENTAGE_COMPLETE', 'PC');
		define('REP_ASSIGNED', 'AG');
		define('REP_MILESTONE', 'MS');
//		define('REP_DEVIANCE', 'DV');
		define('REP_TASK_WORKED_HOURS','WH');
		define('REP_COMMENTS', 'CO');
		define('REP_ACTUAL_START', 'AR');
		define('REP_ACTUAL_FINISH', 'AF');
		define('REP_OVERDUE', 'OD');
		define('REP_IS_BILLABLE', 'BI');
		define('REP_TS_IS_BILLABLE', 'TB');
		
		define('REP_INVOICE_PERIOD', 'IP');
		define('REP_INVOICE_COUNT', 'IC');
		define('REP_INVOICE_AMOUNT','IA');
		define('REP_PAYMENT_COUNT', 'PT');
		define('REP_PAYMENT_AMOUNT','PA');
		define('REP_DEP_INV_COUNT', 'OC');
		define('REP_DEP_INV_AMOUNT', 'OA');
		define('REP_PAY_COUNT', 'YC');
		define('REP_PAY_AMOUNT', 'YA');
		
		define('REP_INVOICE_ID', 'IO');
		define('REP_INVOICE_NUMBER', 'IB');
		define('REP_INVOICE_DATE', 'ID');
		define('REP_CLIENT_CONTACT', 'CE');
		define('REP_AMOUNT', 'AM');
		define('REP_DUE_DATE', 'DD');
		define('REP_INVOICE_STATUS','IT');
		define('REP_OUTSTANDING', 'OS');
		define('REP_ESTIMATE', 'ES');
		define('REP_SUBJECT', 'SU');
		define('REP_RECURRING', 'RR');
		define('REP_NEXT_INV_DATE', 'NI');
		define('REP_DEPOSIT', 'DE');
		define('REP_DISCOUNT', 'DP');
		define('REP_DISCOUNT_AMOUNT', 'DT');
		define('REP_TAX1', 'T1');
		define('REP_TAX1_AMOUNT', 'A1');
		define('REP_TAX2', 'T2');
		define('REP_TAX2_AMOUNT', 'A2');
		define('REP_TAX3', 'T3');
		define('REP_TAX3_AMOUNT', 'A3');
		
		define('REP_7DAY_INTERVAL', '7');
		define('REP_15DAY_INTERVAL', '15');
		define('REP_30DAY_INTERVAL', '30');
		
		define('REP_AGE_DAYS', 'AD');
		define('REP_UNINVOICED_AMOUNT_APPROVED', 'UR');
		define('REP_UNINVOICED_HOURS_UNAPPROVED', 'CU');
		define('REP_UNINVOICED_HOURS_APPROVED', 'CA');
		define('REP_UNINVOICED_EXPENSES_UNAPPROVED', 'EU');
		define('REP_UNINVOICED_EXPENSES_APPROVED', 'EA');
		define('REP_UNINVOICED_AMOUNT_APPROVED_TOTAL','UT');
		
		define('REP_BUDGET', 'BU');
		define('REP_ACTUAL', 'AC');
		define('REP_PERCENT_OF_BUDGET', 'BP');
		define('REP_BUDGET_TYPE','BT');
		define('REP_TASK_FINISH_DATE', 'TD');
		define('REP_ESTIMATED_HOURS', 'EH');
		define('REP_ACTUAL_HOURS', 'AH');
		define('REP_PERCENT_OF_ESTIMATION', 'PE');
		
		define('REP_EXPENSE_PERIOD','XP');
		define('REP_AMOUNT_TOTAL', 'AT');
		define('REP_APPROVED_AMOUNT', 'AA');
		define('REP_UNAPPROVED_AMOUNT', 'UA');
		
		define('REP_EXPENSE_CATEGORY', 'EC');
		define('REP_DETAILS', 'ED');
		define('REP_CLIENT_ID', 'CD');
		define('REP_PROJECT_ID', 'PD');
		define('REP_PROJECT_NUMBER', 'PN');
		define('REP_CURRENCY_CODE', 'CC');
		  
		/*
		 * KEY => array(label, visiblity, data type);
		 * 
		 * 1 or 0 - Enable or disable columns  
		 */

		$this->columns = array(
			REP_CLIENT_ID			=> array('label' => 'CLIENT_ID', 'default' => 2, 'type' => 'S', 'db_select' => "cl.client_id", 'display'=> 0, 'chart'=>0),
			REP_PROJECT_ID			=> array('label' => 'PROJECT_ID', 'default' => 2, 'type' => 'S', 'db_select' => "mt.project_id", 'display'=> 0, 'chart'=>0),
			REP_TASK_TYPE_ID		=> array('label' => 'TASK_TYPE_ID', 'default' => 2, 'type' =>'S', 'db_select' => 'ty.task_type_id', 'display'=> 0, 'chart'=>0),
			REP_PROJECT_NUMBER		=> array('label' => 'PROJECT_NUMBER', 'default' => 2, 'type' => 'S', 'db_select' => "pr.project_id", 'display'=> 0, 'chart'=>0),
			REP_CURRENCY_CODE		=> array('label' => 'CURRENCY_CODE', 'default' => 2, 'type' => 'S', 'db_select' => "inv.currency_code", 'display'=> 0, 'chart'=>0),
			REP_PERIOD 				=> array('label' => 'PERIOD', 'default' => 0,'type' => 'D', 'db_select' => "DATE_FORMAT(ts.entry_date,'%Y-%m-%d')", 'display'=> 1, 'chart'=>0),
			REP_CLIENT				=> array('label' => 'CLIENT', 'default' => 0, 'type' =>'S', 'db_select' => 'concat(cl.client_code, cl.client_name)', 'display'=> 1, 'chart'=>0),
			REP_PROJECT 			=> array('label' => 'PROJECT', 'default' => 0, 'type' =>'S', 'db_select' => 'concat(pr.project_code, pr.project_name)', 'display'=> 1, 'chart'=>1),
			REP_TASK_TYPE 			=> array('label' => 'TASK_TYPE', 'default' => 0, 'type' =>'S', 'db_select' => 'ty.name', 'display'=> 1, 'chart'=>0),
			REP_EXPENSE_TYPE		=> array('label' => 'EXPENSE_TYPE', 'default' => 0, 'type' =>'S', 'db_select' => 'ety.name', 'display'=> 1, 'chart'=>0),
			REP_EXPENSE_QUANTITY	=> array('label' => 'EXPENSE_QUANTITY', 'default' => 0, 'type' => 'N', 'db_select' => 'sum(pre.quantity)', 'display'=> 1, 'chart'=>0),
			REP_UNIT_PRICE			=> array('label' => 'UNIT_PRICE', 'default' => 0, 'type' => 'N', 'db_select' => 'pre.unit_price', 'display'=> 1, 'chart'=>0),
			REP_EXPENSE_AMOUNT		=> array('label' => 'EXPENSE_AMOUNT', 'default' => 0, 'type' => 'N', 'db_select' => 'sum(pre.quantity) * pre.unit_price', 'display'=> 1, 'chart'=>0),
			REP_USER 				=> array('label' => 'USER', 'default' => 0, 'type' =>'S', 'db_select' => 'eu.first_name', 'display'=> 1, 'chart'=>0),
			REP_HOURS 				=> array('label' => 'HOURS', 'default' => 0, 'type' =>'N', 'db_select' => 'sum(ts.hours)', 'display'=> 1, 'chart'=>0),
			REP_TIMESHEET_HOURS		=> array('label' => 'TIMESHEET_HOURS', 'default' => 0, 'type' =>'N', 'db_select' => 'ts.hours', 'display'=> 1, 'chart'=>0),
			REP_BILLABLE_HOURS 		=> array('label' => 'BILLABLE_HOURS', 'default' => 0, 'type' =>'N', 'db_select' => 'sum(ts.hours * ts.is_billable)', 'display'=> 1, 'chart'=>1),
			REP_NON_BILLABLE_HOURS 	=> array('label' => 'NON_BILLABLE_HOURS', 'default' => 0, 'type' =>'N', 'db_select' => 'sum(ts.hours * (! ts.is_billable))', 'display'=> 1, 'chart'=>1),
			REP_BILLABLE_AMOUNT 	=> array('label' => 'BILLABLE_AMOUNT', 'default' => 0, 'type' =>'N', 'db_select' => "SUM(ts.hours * (case pr.invoice_type when 'T' then pty.hourly_rate when 'P' then pru.hourly_rate else 0 end) * ts.is_billable)", 'display'=> 1, 'chart'=>0),
			REP_INVOICED_HOURS		=> array('label' => 'INVOICED_HOURS', 'default' => 0, 'type' =>'N', 'db_select' => 'SUM(ts.hours * ts.invoice_id/ts.invoice_id)', 'display'=> 1, 'chart'=>0),
			REP_UN_INVOICED_HOURS	=> array('label' => 'UN_INVOICED_HOURS', 'default' => 0, 'type' =>'N', 'db_select' => 'SUM(ts.hours * ! ts.invoice_id * ts.is_billable)', 'display'=> 1, 'chart'=>0),
			REP_TASK				=> array('label' => 'TASK', 'default' => 0, 'type' =>'S', 'db_select' => 'case when pt.name is null then ts.activity_name else pt.name end ', 'display'=> 1, 'chart'=>0),
			REP_PROJECT_TASK		=> array('label' => 'PROJECT_TASK', 'default' => 0, 'type' =>'S', 'db_select' => 'pt.name', 'display'=> 1, 'chart'=>0),
			REP_START_AND_END_TIME 	=> array('label' => 'START_AND_END_TIME', 'default' => 0, 'type' =>'S', 'db_select' => 'ts.time_sheet_id', 'display'=> 1, 'chart'=>0),
			REP_TIME_NOTES			=> array('label' => 'TIME_NOTES', 'default' => 0, 'type' =>'S', 'db_select' => 'ts.notes', 'display'=> 1, 'chart'=>0),
			REP_RATE 				=> array('label' => 'RATE', 'default' => 0, 'type' =>'N', 'db_select' => "case pr.invoice_type when 'T' then pty.hourly_rate when 'P' then pru.hourly_rate else 0 end", 'display'=> 1, 'chart'=>0),
			REP_TASK_STATUS 		=> array('label' => 'STATUS', 'default' => 0, 'type' =>'N', 'db_select' => "tt.task_status_id", 'display'=> 1, 'chart'=>0),
			REP_STATUS 				=> array('label' => 'STATUS', 'default' => 0, 'type' =>'S', 'db_select' => "tt.name", 'display'=> 1, 'chart'=>0),
			REP_STATUS_BGCOLOR		=> array('label' => 'STATUS_BGCOLOR', 'default' => 0, 'type' =>'S', 'db_select' => "tt.bg_color", 'display'=> 0, 'chart'=>0),
			REP_STATUS_TEXT_COLOR 	=> array('label' => 'STATUS_TEXT_COLOR', 'default' => 0, 'type' =>'S', 'db_select' => "tt.text_color", 'display'=> 0, 'chart'=>0),
			REP_START 				=> array('label' => 'START', 'default' => 0, 'type' =>'D', 'db_select' => "DATE_FORMAT(pt.start_date,'%Y-%m-%d')", 'display'=> 1, 'chart'=>0),
			REP_FINISH 				=> array('label' => 'FINISH', 'default' => 0, 'type' =>'D', 'db_select' => "DATE_FORMAT(pt.finish_date,'%Y-%m-%d')", 'display'=> 1, 'chart'=>0),
			REP_DURATION 			=> array('label' => 'DURATION', 'default' => 0, 'type' =>'N', 'db_select' => "pt.duration", 'display'=> 1, 'chart'=>0),
			REP_TS_ESTIMATED_HOURS	=> array('label' => 'ESTIMATED_HOURS', 'default' => 0, 'type' =>'N', 'db_select' => "pt.estimated_hours", 'display'=> 1, 'chart'=>0),
			REP_PERCENTAGE_COMPLETE => array('label' => 'PERCENTAGE_OF_COMPLETE', 'default' => 0, 'type' =>'N', 'db_select' => "pt.percentage_complete", 'display'=> 1, 'chart'=>0),
			REP_ASSIGNED 			=> array('label' => 'ASSIGNED', 'default' => 0, 'type' =>'S', 'db_select' => "GROUP_CONCAT(eu.first_name SEPARATOR ',')", 'display'=> 1, 'chart'=>0),
			REP_MILESTONE 			=> array('label' => 'MILESTONE', 'default' => 0, 'type' =>'B', 'db_select' => "if(pt.is_milestone,'Y','N')", 'display'=> 1, 'chart'=>0),
			REP_COMMENTS 			=> array('label' => 'COMMENTS', 'default' => 0, 'type' =>'B', 'db_select' => "if(pt.has_comments,'Y','N')", 'display'=> 1, 'chart'=>0),
//			REP_DEVIANCE 			=> array('label' => 'DEVIANCE', 'default' => 0, 'type' =>'S', 'db_select' => "pt.deviance", 'display'=> 1, 'chart'=>0),
			REP_TASK_WORKED_HOURS 	=> array('label' => 'TASK_WORKED_HOURS', 'default' => 0, 'type' =>'N', 'db_select' => "pt.worked_hours", 'display'=> 1, 'chart'=>0),
			REP_ACTUAL_START 		=> array('label' => 'ACTUAL_START', 'default' => 0, 'type' =>'D', 'db_select' => "DATE_FORMAT(pt.actual_start_date,'%Y-%m-%d')", 'display'=> 1, 'chart'=>0),
			REP_ACTUAL_FINISH 		=> array('label' => 'ACTUAL_FINISH', 'default' => 0, 'type' =>'D', 'db_select' => "DATE_FORMAT(pt.actual_finish_date,'%Y-%m-%d')", 'display'=> 1, 'chart'=>0),
			REP_OVERDUE 			=> array('label' => 'OVERDUE', 'default' => 0, 'type' =>'N', 'db_select' => "(DATEDIFF(DATE_FORMAT(pt.actual_finish_date,'%Y-%m-%d'),DATE_FORMAT(pt.actual_start_date,'%Y-%m-%d')) - DATEDIFF(DATE_FORMAT(pt.finish_date,'%Y-%m-%d'),DATE_FORMAT(pt.start_date,'%Y-%m-%d')))", 'display'=> 1, 'chart'=>0),
			REP_IS_BILLABLE			=> array('label' => 'IS_BILLABLE', 'default' => 0, 'type' =>'B', 'db_select' => "if(pt.is_billable,'Y','N')", 'display'=> 1, 'chart'=>0),
			REP_TS_IS_BILLABLE		=> array('label' => 'IS_BILLABLE', 'default' => 0, 'type' =>'B', 'db_select' => "if(ts.is_billable,'Y','N')", 'display'=> 1, 'chart'=>0),
			REP_INVOICE_PERIOD		=> array('label' => 'INVOICE_PERIOD', 'default' => 0, 'type' =>'D', 'db_select' => "DATE_FORMAT(inv.invoice_date,'%Y-%m-%d')", 'display'=> 1, 'chart'=>0),
			REP_INVOICE_COUNT		=> array('label' => 'INVOICE_COUNT', 'default' => 0, 'type' =>'NC', 'db_select' => "round(sum(!inv.is_deposit))", 'display'=> 1, 'chart'=>0),
			REP_INVOICE_AMOUNT		=> array('label' => 'INVOICE_AMOUNT', 'default' => 0, 'type' =>'N', 'db_select' => "sum(inv.amount * !inv.is_deposit)", 'display'=> 1, 'chart'=>0),
			REP_PAYMENT_COUNT		=> array('label' => 'PAYMENT_COUNT', 'default' => 0, 'type' =>'NC', 'db_select' => "round(sum(invp.invoice_payment_id/invp.invoice_payment_id * !inv.is_deposit))", 'display'=> 1, 'chart'=>0),
			REP_PAYMENT_AMOUNT		=> array('label' => 'PAYMENT_AMOUNT', 'default' => 0, 'type' =>'N', 'db_select' => "sum(invp.amount * (invp.invoice_payment_id/invp.invoice_payment_id) * !inv.is_deposit)", 'display'=> 1, 'chart'=>0),
			REP_DEP_INV_COUNT		=> array('label' => 'DEP_INV_COUNT', 'default' => 0, 'type' =>'NC', 'db_select' => "round(sum(inv.is_deposit))", 'display'=> 1, 'chart'=>0),
			REP_DEP_INV_AMOUNT		=> array('label' => 'DEP_INV_AMOUNT', 'default' => 0, 'type' =>'N', 'db_select' => "sum(inv.amount * inv.is_deposit)", 'display'=> 1, 'chart'=>0),
			REP_PAY_COUNT			=> array('label' => 'PAY_COUNT', 'default' => 0, 'type' =>'S', 'db_select' => "round(sum(invp.invoice_payment_id/invp.invoice_payment_id * inv.is_deposit))", 'display'=> 1, 'chart'=>0, 'chart'=>0),
			REP_PAY_AMOUNT			=> array('label' => 'PAY_AMOUNT', 'default' => 0, 'type' =>'N', 'db_select' => "sum(invp.amount * (invp.invoice_payment_id/invp.invoice_payment_id) * inv.is_deposit)", 'display'=> 1, 'chart'=>0),
			REP_INVOICE_DATE		=> array('label' => 'INVOICE_DATE', 'default' => 0, 'type' =>'D', 'db_select' => "DATE_FORMAT(inv.invoice_date,'%Y-%m-%d')", 'display'=> 1, 'chart'=>0),
			REP_INVOICE_ID			=> array('label' => 'INVOICE_ID', 'default' => 0, 'type' =>'S', 'db_select' => "inv.invoice_id", 'display'=> 1, 'chart'=>0),
			REP_CLIENT_CONTACT		=> array('label' => 'CLIENT_CONTACT', 'default' => 0, 'type' =>'S', 'db_select' => "clc.name", 'display'=> 1, 'chart'=>0),
			REP_AMOUNT				=> array('label' => 'AMOUNT', 'default' => 0, 'type' =>'N', 'db_select' => "inv.amount", 'display'=> 1, 'chart'=>0),
			REP_DUE_DATE			=> array('label' => 'DUE_DATE', 'default' => 0, 'type' =>'D', 'db_select' => "DATE_FORMAT(inv.due_date,'%Y-%m-%d')", 'display'=> 1, 'chart'=>0),
			REP_INVOICE_STATUS		=> array('label' => 'INVOICE_STATUS', 'default' => 0, 'type' =>'S', 'db_select' => "inv.status", 'display'=> 1, 'chart'=>0),
			REP_OUTSTANDING			=> array('label' => 'OUTSTANDING', 'default' => 0, 'type' =>'N', 'db_select' => "(inv.amount-inv.payment_amount)", 'display'=> 1, 'chart'=>0),
			REP_ESTIMATE			=> array('label' => 'ESTIMATE', 'default' => 0, 'type' =>'S', 'db_select' => "inv.estimate_id", 'display'=> 1, 'chart'=>0),
			REP_SUBJECT				=> array('label' => 'SUBJECT', 'default' => 0, 'type' =>'N', 'db_select' => "inv.subject", 'display'=> 1, 'chart'=>0),
			REP_RECURRING			=> array('label' => 'RECURRING', 'default' => 0, 'type' =>'S', 'db_select' => "case COALESCE(inv.recurring_mode, '') when '' then 'No' else 'Yes' end", 'display'=> 1, 'chart'=>0),
			REP_NEXT_INV_DATE		=> array('label' => 'NEXT_INV_DATE', 'default' => 0, 'type' =>'D', 'db_select' => "DATE_FORMAT(inv.recurring_next_inv_date,'%Y-%m-%d')", 'display'=> 1, 'chart'=>0),
			REP_DEPOSIT				=> array('label' => 'DEPOSIT', 'default' => 0, 'type' =>'N', 'db_select' => "case inv.is_deposit when 1 then 'Y' else 'N' end", 'display'=> 1, 'chart'=>0),
			REP_DISCOUNT			=> array('label' => 'DISCOUNT', 'default' => 0, 'type' =>'N', 'db_select' => "inv.discount_percentage", 'display'=> 1, 'chart'=>0),
			REP_DISCOUNT_AMOUNT		=> array('label' => 'DISCOUNT_AMOUNT', 'default' => 0, 'type' =>'N', 'db_select' => "inv.discount_amount", 'display'=> 1, 'chart'=>0),
			REP_TAX1				=> array('label' => 'TAX1', 'default' => 0, 'type' =>'N', 'db_select' => "inv.tax1_percentage", 'display'=> 1, 'chart'=>0),
			REP_TAX1_AMOUNT			=> array('label' => 'TAX1_AMOUNT', 'default' => 0, 'type' =>'N', 'db_select' => "inv.tax1_amount", 'display'=> 1, 'chart'=>0),
			REP_TAX2				=> array('label' => 'TAX2', 'default' => 0, 'type' =>'N', 'db_select' => "inv.tax2_percentage", 'display'=> 1, 'chart'=>0),
			REP_TAX2_AMOUNT			=> array('label' => 'TAX2_AMOUNT', 'default' => 0, 'type' =>'N', 'db_select' => "inv.tax2_amount", 'display'=> 1, 'chart'=>0),
			REP_TAX3				=> array('label' => 'TAX3', 'default' => 0, 'type' =>'N', 'db_select' => "inv.tax3_percentage", 'display'=> 1, 'chart'=>0),
			REP_TAX3_AMOUNT			=> array('label' => 'TAX3_AMOUNT', 'default' => 0, 'type' =>'N', 'db_select' => "inv.tax3_amount", 'display'=> 1, 'chart'=>0),
			REP_7DAY_INTERVAL		=> array('label' => '7DAY_INTERVAL', 'default' => 0, 'type' =>'N', 'db_select' => '', 'display'=> 1, 'chart'=>0),
			REP_15DAY_INTERVAL		=> array('label' => '15DAY_INTERVAL', 'default' => 0, 'type' =>'N', 'db_select' => '', 'display'=> 1, 'chart'=>0),
			REP_30DAY_INTERVAL		=> array('label' => '30DAY_INTERVAL', 'default' => 0, 'type' =>'N', 'db_select' => '', 'display'=> 1, 'chart'=>0),
			REP_AGE_DAYS			=> array('label' => 'AGE_DAYS', 'default' => 0, 'type' =>'NC', 'db_select' => "(DATEDIFF(CURDATE(), inv.due_date))", 'display'=> 1, 'chart'=>0),
			REP_INVOICE_NUMBER		=> array('label' => 'INVOICE_NUMBER', 'default' => 0, 'type' => 'S', 'db_select' => 'inv.invoice_number', 'display'=> 1, 'chart'=>0),
			REP_UNINVOICED_HOURS_UNAPPROVED => array('label' => 'UNINVOICED_HOURS_UNAPPROVED', 'default' => 0, 'type' => 'N', 'db_select' => 'sum(ts.hours*!ts.is_billable * !ts.invoice_id * (case ts.approval_status when "A" then 0 else 1 end))', 'display'=> 1, 'chart'=>0), 
			REP_UNINVOICED_HOURS_APPROVED =>  array('label' => 'UNINVOICED_HOURS_APPROVED', 'default' => 0, 'type' => 'N', 'db_select' => 'sum(ts.hours * !ts.is_billable * !ts.invoice_id * (case ts.approval_status when "A" then 1 else 0 end))', 'display'=> 1, 'chart'=>0),
			REP_UNINVOICED_EXPENSES_UNAPPROVED => array('label' => 'UNINVOICED_EXPENSES_UNAPPROVED', 'default' => 0, 'type' => 'C', 'db_select' => 'sum(pe.amount * !pe.approved_by)', 'display'=> 1, 'chart'=>0),
			REP_UNINVOICED_EXPENSES_APPROVED => array('label' => 'UNINVOICED_EXPENSES_APPROVED', 'default' => 0, 'type' => 'C', 'db_select' => 'sum(pe.amount * pe.approved_by)', 'display'=> 1, 'chart'=>0),
			REP_UNINVOICED_AMOUNT_APPROVED=> array('label' => 'UNINVOICED_AMOUNT_APPROVED', 'default' => 0, 'type' =>'C', 'db_select' => '', 'display'=> 1, 'chart'=>0),
			REP_UNINVOICED_AMOUNT_APPROVED_TOTAL=> array('label' => 'UNINVOICED_AMOUNT_APPROVED_TOTAL', 'default' => 0, 'type' =>'C', 'db_select' => '', 'display'=> 1, 'chart'=>0),
			REP_BUDGET 				=> array('label' => 'BUDGET', 'default' => 0, 'type' =>'N', 'db_select' => 'pr.budget_value', 'display'=> 1, 'chart'=>1),
			REP_BUDGET_TYPE 		=> array('label' => 'BUDGET_TYPE', 'default' => 0, 'type' =>'S', 'db_select' => 'LEFT(pr.budget_type, 1)', 'display'=> 0, 'chart'=>0),
			REP_ACTUAL 				=> array('label' => 'ACTUAL', 'default' => 0, 'type' =>'N', 'db_select' => 'pr.actual_value', 'display'=> 1, 'chart'=>1),
			REP_PERCENT_OF_BUDGET	=> array('label' => 'PERCENT_OF_BUDGET', 'default' => 0, 'type' =>'N', 'db_select' => 'concat(round((pr.actual_value/pr.budget_value)*100), "%")', 'display'=> 1, 'chart'=>0),
			REP_TASK_FINISH_DATE	=> array('label' => 'TASK_FINISH_DATE', 'default' => 0, 'type' =>'D', 'db_select' => 'max(DATE_FORMAT(ts.entry_date, "%Y-%m-%d"))', 'display'=> 1, 'chart'=>0),
			REP_AMOUNT_TOTAL		=> array('label' => 'AMOUNT_TOTAL', 'default' => 0, 'type' =>'C', 'db_select' => 'sum(pe.amount)', 'display'=> 1, 'chart'=>1),
			REP_APPROVED_AMOUNT 	=> array('label' => 'APPROVED_AMOUNT', 'default' => 0, 'type' =>'C', 'db_select' => "sum(pe.amount * pe.approved_by/pe.approved_by)", 'display'=> 1, 'chart'=>1),
			REP_UNAPPROVED_AMOUNT 	=> array('label' => 'UNAPPROVED_AMOUNT', 'default' => 0, 'type' =>'C', 'db_select' => "sum(pe.amount * !pe.approved_by)", 'display'=> 1, 'chart'=>1),
			REP_EXPENSE_PERIOD 		=> array('label' => 'EXPENSE_PERIOD', 'default' => 0,'type' => 'D', 'db_select' => "DATE_FORMAT(pe.expense_date,'%Y-%m-%d')", 'display'=> 1, 'chart'=>1),
			REP_EXPENSE_CATEGORY	=> array('label' => 'EXPENSE_CATEGORY', 'default' => 0, 'type' =>'S', 'db_select' => 'ey.name', 'display'=> 1, 'chart'=>0),
			REP_DETAILS				=> array('label' => 'Details', 'default' => 0, 'type' =>'S', 'db_select' => 'pe.notes', 'display'=> 1, 'chart'=>0),
			REP_ESTIMATED_HOURS		=> array('label' => 'ESTIMATED_HOURS', 'default' => 0, 'type' =>'N', 'db_select' => 'pty.estimated_hours', 'display'=> 1, 'chart'=>0),
			REP_ACTUAL_HOURS		=> array('label' => 'ACTUAL_HOURS', 'default' => 0, 'type' =>'N', 'db_select' => 'pty.actual_hours', 'display'=> 1, 'chart'=>0),
			REP_PERCENT_OF_ESTIMATION=> array('label' => 'PERCENT_OF_ESTIMATION', 'default' => 0, 'type' =>'N', 'db_select' => '((pty.estimated_hours/pty.actual_hours)*100)', 'display'=> 1, 'chart'=>0),
		);
		
		$class = 'Member';

		if (is_admin())
		{
			$class = 'Admin';
		} else if (is_pmf())
		{
			$class = 'Pmf';
		} else if(is_pm())
		{
			$class = 'pm';
		}

		$class.='_report_lib';

		$this->class = new $class;
	}

	function get_columns ($data, $report_columns = array())
	{
		$default_columns = $result = array();
		$report_code 	 = $data['report_code'];
		
		$method = 'get_'.strtolower($report_code).'_columns';
		$user_columns = $this->class->$method();
	
		if (!$report_columns) {
			$report_columns = $user_columns;
			 
			$method = 'get_'.strtolower($report_code).'_columns_default';
			$default_columns = $this->class->$method();
		} else {
			$tmp_columns = $report_columns;
			$report_columns = array();
			foreach ($user_columns as $col) {
				$report_columns[$col] = isset($tmp_columns[$col])?$tmp_columns[$col]:0;
			}
		}

		if (strtolower($report_code)=='ad') {
			$this->columns[REP_STATUS]['display'] = 0;
		}

		if ($report_columns)
		{	
			unset($report_columns['DV']);
			if(!empty($report_columns['detail_filter'])) {
				unset($report_columns['detail_filter']);
			}
			if ($default_columns)
			{
				if(!empty($data['group_by'])) {
					if (!in_array($data['group_by'], $default_columns)) {
						if (!in_array($data['group_by'], $report_columns))
							$report_columns = array_merge( array($data['group_by']), $report_columns);
						$default_columns[]  = $data['group_by'];
					}
				}
				
				// Load default columns settings
				foreach ($report_columns as $val)
				{
					$tmp		= $this->columns[$val];
					$tmp['label']	= lang($tmp['label']);
					$tmp['default']	= (in_array($val,$default_columns))?1:$tmp['default'];
									
					if (($tmp['default'] || $tmp['chart']) && $tmp['db_select'])
						$result['db_select'][$val]	= array($tmp['db_select'].' AS '. $val, $tmp['type'], $tmp['default']);
					unset($tmp['db_select']);
					
					$result['columns'][]	= array_merge(array($val),array_values($tmp));
				}
				
			} else {
				// load columns based on user setting
				if(!empty($data['group_by'])) {
					
					$report_columns = array_merge( array($data['group_by'] => 1), $report_columns);
					$report_columns[$data['group_by']] = 1;
				}
				foreach ($report_columns as $key => $val)
				{
					$tmp		= $this->columns[$key];
					$tmp['label']	= lang($tmp['label']);
					$tmp['default']	= $val;
									
					if (($tmp['default'] || $tmp['chart']) && $tmp['db_select'])
						$result['db_select'][$key]	= array($tmp['db_select'].' AS '. $key, $tmp['type'], $tmp['default']);
					unset($tmp['db_select']);
					
					$result['columns'][]	= array_merge(array($key),array_values($tmp));
				}
			
			}
		}

		return $result;
	}
	
	public function get_detail_group_by($data)
	{
		$result = array();
		$report_code 	 = $data['report_code'];

		if ($report_code) {
			$method = 'get_'.strtolower($report_code).'_groupby_columns';
			if(method_exists($this->class, $method)) {
				$result = $this->class->$method();
			}
		}
		return $result;
	}
	

	public function __call($method, $arguments)
	{
		return $this->class->$method($arguments);
	}
}

/*
 *  Member role
 */

class Member_report_lib {

	function __construct()
	{
		//parent::__construct();
	}
	
	public function get_ts_columns()
	{
		//return array(REP_PERIOD, REP_HOURS, REP_BILLABLE_HOURS, REP_NON_BILLABLE_HOURS, REP_BILLABLE_AMOUNT, REP_INVOICED_HOURS, REP_UN_INVOICED_HOURS );
		return array(REP_HOURS, REP_BILLABLE_HOURS, REP_NON_BILLABLE_HOURS);
	}
	
	public function get_ts_groupby_columns()
	{
		return array(REP_CLIENT => 'cl.client_id', REP_PROJECT => 'pr.project_id', REP_TASK => 'ts.activity_name', REP_USER => 'eu.user_id', REP_PERIOD => 'ts.entry_date');
	}
	
	public function get_ts_columns_default()
	{
		return array(REP_HOURS, REP_BILLABLE_HOURS);
	}
	
	public function get_td_columns()
	{
		return array(REP_PERIOD, REP_CLIENT, REP_PROJECT, REP_TASK_TYPE, REP_USER, REP_TASK, REP_HOURS, REP_START_AND_END_TIME, REP_TIME_NOTES, REP_BILLABLE_HOURS,REP_NON_BILLABLE_HOURS);
	}
	
	public function get_td_columns_default()
	{
		return array(REP_CLIENT, REP_PROJECT, REP_TASK_TYPE, REP_HOURS, REP_BILLABLE_HOURS, REP_TASK);
	}
	
	public function get_td_groupby_columns()
	{
		return array(REP_CLIENT => 'cl.client_id', REP_PROJECT => 'pr.project_id', REP_TASK => 'ts.activity_name', REP_USER => 'eu.user_id', REP_PERIOD => 'ts.entry_date');
	}
	
	public function get_ed_groupby_columns()
	{
		return array(REP_CLIENT => 'cl.client_id', REP_PROJECT => 'pr.project_id', REP_TASK => 'ts.activity_name', REP_USER => 'eu.user_id', REP_PERIOD => 'ts.entry_date');
	}
	
	public function get_columns_td ()
	{
		return array(REP_PERIOD, REP_HOURS, REP_BILLABLE_HOURS, REP_NON_BILLABLE_HOURS, REP_BILLABLE_AMOUNT, REP_BILLABLE_HOURS, REP_INVOICED_HOURS, REP_UN_INVOICED_HOURS );
	}

	// Task begins
	public function get_as_columns()
	{
		return array(REP_PROJECT_TASK, REP_CLIENT, REP_PROJECT, REP_TASK_TYPE,  REP_STATUS, REP_STATUS_BGCOLOR, REP_STATUS_TEXT_COLOR, REP_START, REP_FINISH, REP_ASSIGNED, REP_IS_BILLABLE, REP_MILESTONE, REP_HOURS, REP_TASK_WORKED_HOURS, REP_TS_ESTIMATED_HOURS, REP_COMMENTS);
	}
	
	public function get_as_columns_default()
	{
		return array(REP_PROJECT_TASK, REP_STATUS, REP_STATUS_BGCOLOR, REP_STATUS_TEXT_COLOR, REP_START, REP_FINISH, REP_PERCENTAGE_COMPLETE);
	}

	public function get_ad_columns()
	{
		return array(REP_PROJECT_TASK, REP_USER, REP_TASK_TYPE, REP_PERIOD, REP_HOURS, REP_TS_ESTIMATED_HOURS, REP_TS_IS_BILLABLE, REP_STATUS, REP_STATUS_BGCOLOR, REP_STATUS_TEXT_COLOR);
	}
	
	public function get_ad_columns_default()
	{
		return array(REP_USER,REP_PROJECT_TASK,REP_TASK_TYPE,REP_PERIOD, REP_HOURS, REP_TS_ESTIMATED_HOURS,  REP_TS_IS_BILLABLE,REP_STATUS, REP_STATUS_BGCOLOR, REP_STATUS_TEXT_COLOR);
	}
	// Task End
	public function get_es_columns()
	{
		return array(REP_EXPENSE_PERIOD, REP_APPROVED_AMOUNT, REP_UNAPPROVED_AMOUNT, REP_AMOUNT_TOTAL);
	}
	public function get_es_columns_default()
	{
		return array(REP_EXPENSE_PERIOD, REP_APPROVED_AMOUNT);
	}
	public function get_ed_columns()
	{
		return array(REP_EXPENSE_PERIOD, REP_CLIENT, REP_PROJECT, REP_EXPENSE_CATEGORY, REP_USER, REP_DETAILS, REP_APPROVED_AMOUNT, REP_UNAPPROVED_AMOUNT, REP_AMOUNT_TOTAL);
	}
	public function get_ed_columns_default()
	{
		return array(REP_EXPENSE_PERIOD, REP_CLIENT, REP_PROJECT, REP_EXPENSE_CATEGORY, REP_USER, REP_DETAILS);
	} 
}

/*
 *  Project manager role
 */

class Pm_report_lib extends Member_report_lib 
{
	function __construct()
	{
		parent::__construct();
	}
}

/*
 *  Project manager finance role
 */

class Pmf_report_lib extends Pm_report_lib 
{
	function __construct()
	{
		parent::__construct();
	}
	public function get_ed_columns()
	{
		return array(REP_EXPENSE_PERIOD, REP_CLIENT, REP_PROJECT, REP_EXPENSE_CATEGORY, REP_USER, REP_DETAILS, REP_AMOUNT_TOTAL, REP_APPROVED_AMOUNT, REP_UNAPPROVED_AMOUNT);
	}
	public function get_ed_columns_default()
	{
		return array(REP_EXPENSE_PERIOD, REP_CLIENT, REP_PROJECT, REP_EXPENSE_CATEGORY, REP_USER, REP_DETAILS, REP_AMOUNT_TOTAL);
	} 
	public function get_is_columns()
	{
		return array(REP_CURRENCY_CODE, REP_INVOICE_COUNT, REP_INVOICE_AMOUNT, REP_PAYMENT_COUNT, REP_PAYMENT_AMOUNT, REP_DEP_INV_COUNT, REP_DEP_INV_AMOUNT, REP_PAY_COUNT, REP_PAY_AMOUNT);
	}
	public function get_is_columns_default()
	{
		return array(REP_CURRENCY_CODE, REP_INVOICE_COUNT, REP_INVOICE_AMOUNT, REP_PAYMENT_COUNT, REP_PAYMENT_AMOUNT, REP_DEP_INV_COUNT, REP_DEP_INV_AMOUNT, REP_PAY_COUNT, REP_PAY_AMOUNT);
	}
	public function get_id_columns()
	{
		return array(REP_INVOICE_DATE, REP_INVOICE_NUMBER, REP_CURRENCY_CODE, REP_CLIENT, REP_CLIENT_CONTACT, REP_AMOUNT, REP_DUE_DATE, REP_INVOICE_STATUS, REP_OUTSTANDING, REP_ESTIMATE, REP_SUBJECT, REP_RECURRING, REP_NEXT_INV_DATE, REP_DEPOSIT, REP_DISCOUNT, REP_DISCOUNT_AMOUNT, REP_TAX1, REP_TAX1_AMOUNT, REP_TAX2, REP_TAX2_AMOUNT, REP_TAX3, REP_TAX3_AMOUNT);
	}
	public function get_id_columns_default()
	{
		return array(REP_INVOICE_DATE, REP_CURRENCY_CODE, REP_CLIENT, REP_AMOUNT, REP_INVOICE_STATUS, REP_OUTSTANDING);
	}
	public function get_ia_columns()
	{
		return array(REP_7DAY_INTERVAL, REP_15DAY_INTERVAL, REP_30DAY_INTERVAL);
	}
	public function get_ia_columns_default()
	{
		return array(REP_7DAY_INTERVAL, REP_15DAY_INTERVAL, REP_30DAY_INTERVAL);
	}
	public function get_io_columns()
	{
		return array(REP_CURRENCY_CODE, REP_INVOICE_DATE, REP_DUE_DATE, REP_INVOICE_NUMBER, REP_CLIENT, REP_AGE_DAYS, REP_AMOUNT, REP_OUTSTANDING);
	}
	public function get_io_columns_default()
	{
		return array(REP_INVOICE_DATE, REP_DUE_DATE, REP_INVOICE_NUMBER, REP_CLIENT, REP_AGE_DAYS, REP_AMOUNT, REP_OUTSTANDING);
	}
	public function get_iu_columns()
	{
		return array(REP_CLIENT_ID, REP_PROJECT_ID, REP_CLIENT, REP_PROJECT, REP_UNINVOICED_HOURS_APPROVED, REP_UNINVOICED_HOURS_UNAPPROVED, REP_UNINVOICED_EXPENSES_APPROVED, REP_UNINVOICED_EXPENSES_UNAPPROVED, REP_UNINVOICED_AMOUNT_APPROVED, REP_UNINVOICED_AMOUNT_APPROVED_TOTAL);
	}
	public function get_iu_columns_default()
	{
		return array(REP_CLIENT, REP_PROJECT, REP_UNINVOICED_HOURS_APPROVED, REP_UNINVOICED_HOURS_UNAPPROVED, REP_UNINVOICED_EXPENSES_APPROVED, REP_UNINVOICED_EXPENSES_UNAPPROVED, REP_UNINVOICED_AMOUNT_APPROVED);
	}
	public function get_uo_columns()
	{
		return array(REP_PERIOD, REP_PROJECT, REP_TASK_TYPE, REP_USER, REP_TIMESHEET_HOURS);		
	}
	public function get_uo_columns_default()
	{
		return array(REP_PERIOD, REP_PROJECT, REP_TASK_TYPE, REP_USER, REP_TIMESHEET_HOURS);		
	}
	public function get_ue_columns()
	{
		return array(REP_PROJECT, REP_EXPENSE_TYPE, REP_USER, REP_EXPENSE_QUANTITY, REP_UNIT_PRICE, REP_EXPENSE_AMOUNT);		
	}
	public function get_ue_columns_default()
	{
		return array(REP_PROJECT, REP_EXPENSE_TYPE, REP_USER, REP_EXPENSE_QUANTITY, REP_UNIT_PRICE, REP_EXPENSE_AMOUNT);		
	}
	public function get_bu_columns()
	{
		return array(REP_CLIENT_ID, REP_PROJECT_NUMBER, REP_CLIENT, REP_PROJECT, REP_BUDGET, REP_BUDGET_TYPE, REP_ACTUAL, REP_PERCENT_OF_BUDGET, REP_TASK_FINISH_DATE);
	}
	public function get_bu_columns_default()
	{
		return array(REP_CLIENT_ID, REP_PROJECT_NUMBER, REP_CLIENT, REP_PROJECT, REP_BUDGET, REP_BUDGET_TYPE, REP_ACTUAL, REP_PERCENT_OF_BUDGET, REP_TASK_FINISH_DATE);
	}
	public function get_bd_columns()
	{
		return array(REP_CLIENT_ID, REP_PROJECT_NUMBER, REP_TASK_TYPE_ID, REP_BUDGET_TYPE, REP_TASK_TYPE, REP_ESTIMATED_HOURS, REP_ACTUAL_HOURS, REP_PERCENT_OF_ESTIMATION, REP_TASK_FINISH_DATE);
	}
	public function get_bd_columns_default()
	{
		return array(REP_CLIENT_ID, REP_PROJECT_NUMBER, REP_TASK_TYPE_ID, REP_BUDGET_TYPE, REP_TASK_TYPE, REP_ESTIMATED_HOURS, REP_ACTUAL_HOURS, REP_PERCENT_OF_ESTIMATION, REP_TASK_FINISH_DATE);
	}
}

/*
 *  Administrator role
 */
class Admin_report_lib extends Pmf_report_lib 
{
	public function __construct() {
        parent::__construct();
    }

	public function get_ts_columns()
	{
		return array(REP_HOURS, REP_BILLABLE_HOURS, REP_NON_BILLABLE_HOURS, REP_BILLABLE_AMOUNT, REP_INVOICED_HOURS, REP_UN_INVOICED_HOURS );
	}
	
	public function get_ts_columns_default()
	{
		return array(REP_HOURS, REP_BILLABLE_HOURS, REP_BILLABLE_AMOUNT, REP_UN_INVOICED_HOURS);
	}
	
	public function get_td_columns()
	{
		return array(REP_PERIOD, REP_CLIENT, REP_PROJECT, REP_TASK_TYPE, REP_USER, REP_TASK, REP_HOURS, REP_START_AND_END_TIME, REP_TIME_NOTES, REP_BILLABLE_HOURS,REP_NON_BILLABLE_HOURS, REP_RATE, REP_BILLABLE_AMOUNT, REP_INVOICED_HOURS, REP_UN_INVOICED_HOURS);
	}
	
	public function get_td_columns_default()
	{
		return array(REP_CLIENT, REP_PROJECT, REP_TASK_TYPE, REP_HOURS, REP_BILLABLE_HOURS, REP_TASK);
	}
}
