<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

	$is_ajax_request	= $this->input->is_ajax_request();

	if (!$is_ajax_request)
	{
		$this->load->view("header");
	}

	$domain = isset($domain)?$domain:'';

	$fields	= array(
		'form_open'	=> array(
			'id'			=> 'signup_form',
			'name'			=> 'signup_form',
			'class'			=> 'form-register form-horizontal col-md-4 col-md-offset-4',
			'action'		=> '/home/signup',
			'method'		=> 'post',
			'data-bind'		=> 'submit:onSubmit',
		),
		'company_name' => array(
			'class'			=> 'form-control input-lg',
			'name'			=> 'company_name',
			'id'			=> 'company',
			'placeholder'	=> 'Company',
			'minlength'		=> '5',
			'maxlength'		=> '60',
			'data-bind'		=> 'value:company_name',
		),
		'domain_url'		=> array(
			'class'			=> 'form-control input-lg',
			'name'			=> 'domain_url',
			'id'			=> 'subdomain',
			'placeholder'	=> 'Sub-Domain',
			'minlength'		=> '4',
			'maxlength'		=> '16',
			'data-bind'		=> 'value:domain_url',
		),
		'user_name'		=> array(
			'class'			=> 'form-control input-lg',
			'name'			=> 'user_name',
			'id'			=> 'admin_name',
			'placeholder'	=> 'Administrator Name',
			'minlength'		=> '4',
			'maxlength'		=> '60',
			'data-bind'		=> 'value:user_name',
		),
		'email'		=> array(
			'class'			=> 'form-control input-lg',
			'name'			=> 'email',
			'id'			=> 'admin_email',
			'placeholder'	=> 'Administrator Email',
			'maxlength'		=> '80',
			'data-bind'		=> 'value:email',
			'type'			=> 'email',
		),
		'password'		=> array(
			'class'			=> 'form-control input-lg',
			'name'			=> 'password',
			'id'			=> 'admin_password',
			'placeholder'	=> 'Administrator Password',
			'minlength'		=> '6',
			'maxlength'		=> '12',
			'data-bind'		=> 'value:password, valueUpdate:\'afterkeydown\'',
		),
		'confirm_password'		=> array(
			'class'			=> 'form-control input-lg',
			'name'			=> 'confirm_password',
			'id'			=> 'confirm_password',
			'placeholder'	=> 'Confirm Password',
			'minlength'		=> '6',
			'maxlength'		=> '12',
			'data-bind'		=> 'value:confirm_password, visible:password().length',
		),
		'_subdom'	=> array(
			'name'			=> '_subdom',
			'data-bind'		=> 'value:_subdom',
			'type'			=> 'hidden'
		),
	);
?>
<div id="signup-container" class="container">
	<div id="alert_message">
		<?php echo out_message(); ?>
	</div>
	<?php echo form_open('home/signup', $fields['form_open']); ?>
	<div class="row">
		<div>
			<?php echo form_input($fields['company_name']); ?>
		</div>
	</div>
	<div class="sep">&nbsp;</div>
	<div class="row">
		<div class="input-group col-md-8 col-sm-9 col-xs-7 np pull-left">
			<span id="domain" ></span>
			<?php
				echo form_input($fields['domain_url']);
				echo form_input($fields['_subdom']);
			?>
		</div>
		<div class="col-md-4 col-sm-3 col-xs-5 np">
			<span class="dib input-lg npr npl">&nbsp;.<?php echo $this->config->item('domain');?></span>
		</div>
	</div>
	<div class="sep">&nbsp;</div>
	<div class="row">
		<div class="input-group">
			<span class="input-group-addon">
				<span class="icon-user"></span>
			</span>
			<?php echo form_input($fields['user_name']); ?>
		</div>
	</div>
	<div class="sep">&nbsp;</div>
	<div class="row">
		<div class="input-group">
			<span class="input-group-addon">@</span>
			<?php echo form_input($fields['email']); ?>
		</div>
	</div>
	<div class="sep">&nbsp;</div>
	<div class="row">
		<div class="input-group">
			<span class="input-group-addon">
				<span class="icon-lock"></span>
			</span>
			<?php echo form_password($fields['password']); ?>
		</div>
	</div>
	<div class="sep">&nbsp;</div>	
	<div class="row" data-bind="visible:password().length">
		<div class="input-group">
			<span class="input-group-addon">
				<span class="icon-lock"></span>
			</span>
			<?php echo form_password($fields['confirm_password']); ?>
		</div>
	</div>
	<div class="sep">&nbsp;</div>	
		<div class="row small">By clicking you agree to the <a href="#" target="_blank"><?php echo lang('CUS_AGREEMENT');?></a> and <a href="http://www.srimax.com/index.php/privacy-policy/"  target="_blank"><?php echo lang('PRI_POLICY');?></a>.</div>
	<div class="sep">&nbsp;</div>	
	<div class="row ac">
		<div class="">
			<input type="submit" class="btn btn-primary btn-lg btn-block" value="<?php echo lang('SIGNUP'); ?>" />
		</div>
	</div>
	<div class="sep">&nbsp;</div>
	<div class="row">
		<div class="pull-right">
			<a href="<?php echo site_url('home/domain'); ?>" class="text-primary"><?php echo lang("FORGOT_DOMAIN_LINK"); ?></a>
		</div>
	</div>
	<?php if ($domain) { ?>
		<input type="hidden" value="<?php echo $domain;?>" name="gdomain" id="gdomain"/>
	<?php }
	echo form_close();  
?>
</div>
<?php
	$jslang['COMPANY_REQUIRED']			= lang('FIELD_REQUIRED', lang('COMPANY'));
	$jslang['SUBDOMAIN_NAME_REQUIRED']	= lang('FIELD_REQUIRED', lang('SUBDOMAIN'));
	$jslang['ADMIN_NAME_REQUIRED']		= lang('FIELD_REQUIRED', lang('ADMIN_NAME'));
	$jslang['ADMIN_PASSWORD_REQUIRED']	= lang('FIELD_REQUIRED', lang('ADMIN_PASSWORD'));
	$jslang['CONFIRM_PASSWORD_REQUIRED']= lang('FIELD_REQUIRED', lang('CONFIRM_PASSWORD'));
	$jslang['COMPANY_LENGTH']			= lang('COMPANY_LENGTH');
	$jslang['SUBDOMAIN_LENGTH']			= lang('SUBDOMAIN_LENGTH');
	$jslang['ADMIN_NAME_LENGTH']		= lang('ADMIN_NAME_LENGTH');
	$jslang['ADMIN_PASSWORD_LENGTH']	= lang('ADMIN_PASSWORD_LENGTH');	
	$jslang['CONFIRM_PASSWORD_DIFFERENT']= lang('CONFIRM_PASSWORD_DIFFERENT');
	$jslang['INVALID_EMAIL']			= lang('INVALID_EMAIL');
	$jslang['SUCCESS_SAVE']				= lang('SUCCESS_SAVE');
	$jslang['SUBDOMAIN_NAME_NOT_YET_VERIFIED']	= lang('SUBDOMAIN_NAME_NOT_YET_VERIFIED');

	if (!$is_ajax_request)
	{
		$this->load->view("footer");
	}
?>
<script type="text/javascript">
	$(document).ready(function(){
		window.site_url = "<?php echo site_url(); ?>/";
		ko.applyBindings(new Signup({
			lang: <?php echo json_encode($jslang); ?>
			<?php if ($domain) {
				echo ",domain_url:'".$domain."'";
			}?>
		}), $('#signup-container').get(0));
	});
</script>
