<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

	$is_ajax_request	= $this->input->is_ajax_request();

	if (!$is_ajax_request)
	{
		$this->load->view("header");
	}

	$date_filter_this	= array(
		'TO' => 'TODAY',
		'TW' => 'THIS_WEEK',
		'TS' => 'THIS_SEMI_MONTHLY',
		'TM' => 'THIS_MONTH',
		'TQ' => 'THIS_QUARTER',
		'TY' => 'THIS_YEAR',
		'TA' => 'THIS_ACCOUNT_YEAR'
	);
	$date_filter_last	= array(
		'YE' => 'YESTERDAY',
		'LW' => 'LAST_WEEK',
		'LS' => 'LAST_SEMI_MONTHLY',
		'LM' => 'LAST_MONTH',
		'LQ' => 'LAST_QUARTER',
		'LY' => 'LAST_YEAR',
		'LA' => 'LAST_ACCOUNT_YEAR'
	);
?>
<div id="report-container" class="">
	<div class="page-header-bar">
		<span class="title"><?php echo lang('REPORTS_TITLE'); ?></span>
		<ul class="btns list-inline">
			<li>
				<!-- <a href="javascript:;" id="share" data-bind="click:preparelink()"><i class="icon-link icon-metro img-circle"></i></a> -->
				<a href="javascript:;" id="csv" title="CSV" data-bind="click:refresh('csv')"><i class="oticon-csv icon-metro img-circle"></i></a>
				<a href="javascript:;" id="xls" title="XLS" data-bind="click:refresh('xls')"><i class="oticon-excel icon-metro img-circle"></i></a>
				<a href="javascript:;" id="pdf" title="PDF" data-bind="click:refresh('pdf')"><i class="oticon-pdf icon-metro img-circle"></i></a>
			</li>
		</ul>
	</div>
	<div class="clearfix"></div>
	<div id="body-container">
		<div class="row nm" data-bind="css:{'pinned':isPinned, 'un-pinned':!isPinned()}">
			<span class="fix-setting" data-bind="hidden:isPannel, click:swapPanel"><i class="icon icon-cog"></i></span>
			<div id="left-panel" class="page-sidebar panel panel-default left-panel" data-bind="css:{'col-md-3 npr npl':isPinned, 'open':isPannel}">
				<div class="panel-heading">
<?php 	//			<span class="cp pull-right" data-bind="click:swapPanel, hidden:isPinned"><i class="icon icon-remove"></i></span> ?>
					<span class="cp pull-right" style="margin-right:10px;" data-bind="click:swapPin"><i class="icon icon-pushpin"></i></span>
				</div>
				<div class="masonry opened panel-body" id="list-container">
					<div class="row nm" data-bind="if:(_info.report_code()!='U')">
						<div data-bind="with:_info.filters">
						<?php if (!is_member()) {?>
							<div class="form-group">
								<select id="selCL" data-placeholder="Select a clients..." data-bind="options:$parent._info.clients, optionsText:'client_name', optionsValue:'client_id', selectedOptions:CL,chosen:{change:chosenChange}" multiple="multiple" class="form-control">
								</select>
							</div>
							<?php } ?>
							<div class="form-group" data-bind="visible:$parent._info.report_code()=='I'">
								<select id="selIT" data-placeholder="Select a Status..." data-bind="enable: $parent._info.view() == 'D', selectedOptions:IT, chosen:{change:chosenChange}" multiple="multiple" class="chosen-select">
									<option value="all"><?php echo lang('ALL_STATUS'); ?></option>
									<?php
										foreach ($status as $key=>$value)
										{
											echo('<option value="' . $key . '">' . $value . '</option>');
										}
									?>
								</select>
							</div>
							<!-- ko if:$parent._info.report_code()!="I" -->
							<div class="form-group">
								<select id="selPR" data-placeholder="Select a projects..." data-bind="options:$parent._info.projects, optionsText:'project_name', optionsValue:'project_id',selectedOptions:PR, chosen:{change:chosenChange}" multiple="multiple" class="form-control">
								</select>
							</div>
							<div class="form-group" data-bind="visible:$parent._info.report_code()=='E'">
								<select id="selEC" data-placeholder="Select a Category..." data-bind="selectedOptions:EC, chosen:{change:chosenChange}" multiple="multiple" class="form-control">
									<option value="all"><?php echo lang('ALL_EXP_CATEGORIES'); ?></option>
									<?php
										foreach ($categories as $row)
										{
											echo('<option value="' . $row['expense_type_id'] . '">' . $row['name'].'</option>');
										}
									?>
								</select>
							</div>
							<!-- ko if:$parent._info.report_code()!="BU" && $parent._info.report_code()!='BD' -->
							<div class="form-group" data-bind="visible:$parent._info.report_code()!='E'">
								<select id="selTT" data-placeholder="Select a task types..." data-bind="selectedOptions:TT, chosen:{change:chosenChange}" multiple="multiple" class="form-control">
									<option value="all"><?php echo lang('ALL_TASK_TYPES'); ?></option>
									<?php
										foreach ($task_types as $row)
										{
											echo('<option value="' . $row['task_type_id'] . '">' . $row['name'].'</option>');
										}
									?>
								</select>
							</div>
							<?php if (!is_member()) {?>
								<div class="form-group">
									<select id="selUS" data-placeholder="Select a users..." data-bind="options:$parent._info.users, optionsText:'first_name', optionsValue:'user_id',selectedOptions:US, chosen:{change:chosenChange}" multiple="multiple" class="form-control">
										<option value="all"><?php echo lang('ALL_USERS'); ?></option>
										<?php
											foreach ($users as $row)
											{
												echo('<option value="' . $row['user_id'] . '">' . $row['first_name'].'</option>');
											}
										?>
									</select>
								</div>
							<?php } ?>
							<!-- /ko -->
							<!-- /ko -->
							<div class="form-group" data-bind="visible:$parent._info.report_code()=='A'">
								<select id="selTKS" data-placeholder="Select a Status..." data-bind="selectedOptions:TKS, chosen:{change:chosenChange}" multiple="multiple" class="chosen-select">
									<option value="all"><?php echo lang('ALL_STATUS'); ?></option>
									<?php
										foreach ($task_status as $key=>$value)
										{
											echo('<option value="' . $value['task_status_id'] . '">' . $value['name'] . '</option>');
										}
									?>
								</select>
							</div>
						</div>
					</div>
					<div class="row nm" data-bind="if:show_group_by">
						<h5><?php echo lang('GROUP_BY'); ?></h5>
						<div class="btn-group btn-toggle">
							<button class="btn btn-sm" data-bind="css:{'btn-primary active':_info.group_by()=='<?php echo REP_CLIENT; ?>', 'btn-default':_info.group_by()!='<?php echo REP_CLIENT; ?>'}, click:setGroupBy('<?php echo REP_CLIENT; ?>')"><?php echo lang('CLIENT'); ?></button>
							<!-- ko if:_info.report_code()=='I' -->
							<button class="btn btn-sm" data-bind="css:{'btn-primary active':_info.group_by()=='<?php echo REP_INVOICE_PERIOD; ?>', 'btn-default':_info.group_by()!='<?php echo REP_INVOICE_PERIOD; ?>'}, click:setGroupBy('<?php echo REP_INVOICE_PERIOD; ?>')"><?php echo lang('DATE'); ?></button>
							<!-- /ko -->
							<!-- ko if:_info.report_code()!='I' -->
							<button class="btn btn-sm" data-bind="css:{'btn-primary active':_info.group_by()=='<?php echo REP_PROJECT; ?>', 'btn-default':_info.group_by()!='<?php echo REP_PROJECT; ?>'}, click:setGroupBy('<?php echo REP_PROJECT; ?>'), visible:_info.report_code()!='I'"><?php echo lang('PROJECT'); ?></button>
							<!-- /ko -->
							<!-- ko if:_info.report_code()=='T' -->
							<button class="btn btn-sm" data-bind="css:{'btn-primary active':_info.group_by()=='<?php echo REP_TASK_TYPE; ?>', 'btn-default':_info.group_by()!='<?php echo REP_TASK_TYPE; ?>'}, click:setGroupBy('<?php echo REP_TASK_TYPE; ?>'), visible:_info.report_code()!='I'"><?php echo lang('TASK'); ?></button>
							<!-- /ko -->
							<!-- ko if:_info.report_code()!='I' -->
							<button class="btn btn-sm" data-bind="css:{'btn-primary active':_info.group_by()=='<?php echo REP_USER; ?>', 'btn-default':_info.group_by()!='<?php echo REP_USER; ?>'}, click:setGroupBy('<?php echo REP_USER; ?>')"><?php echo lang('USER'); ?></button>
							<!-- /ko -->
							<!-- ko if:(_info.report_code()=='T') -->
							<button class="btn btn-sm" data-bind="css:{'btn-primary active':_info.group_by()=='<?php echo REP_PERIOD; ?>', 'btn-default':_info.group_by()!='<?php echo REP_PERIOD; ?>'}, click:setGroupBy('<?php echo REP_PERIOD; ?>')"><?php echo lang('DATE'); ?></button>
							<!-- /ko -->
							<!-- ko if:_info.report_code()=='E' -->
							<button class="btn btn-sm" data-bind="css:{'btn-primary active':_info.group_by()=='<?php echo REP_EXPENSE_CATEGORY; ?>', 'btn-default':_info.group_by()!='<?php echo REP_EXPENSE_CATEGORY; ?>'}, click:setGroupBy('<?php echo REP_EXPENSE_CATEGORY; ?>'), visible:_info.report_code()!='I'"><?php echo lang('EXPENSE'); ?></button>
							<button class="btn btn-sm" data-bind="css:{'btn-primary active':_info.group_by()=='<?php echo REP_EXPENSE_PERIOD; ?>', 'btn-default':_info.group_by()!='<?php echo REP_EXPENSE_PERIOD; ?>'}, click:setGroupBy('<?php echo REP_EXPENSE_PERIOD; ?>')"><?php echo lang('DATE'); ?></button>
							<!-- /ko -->
						</div>
					</div>
					<div class="clearfix">&nbsp;</div>
					<div class="row nm accordion">
						<div class="accordion-group" data-bind="if:show_view">
							<div class="accordion-heading">
								<h3><?php echo lang('VIEWS'); ?></h3>
							</div>
							<div class="accordion-body">
								<table class="table table-collapsed borderless">
									<tbody>
										<tr>
											<td  class="npt"><div class="radio nm"><label><input type="radio" name="view" value="S" data-bind="checked:_info.view"  style="margin-top: 2px;"/><?php echo lang('SUMMARY'); ?></label></div></td>
										</tr>
										<tr>
											<td  class="npt"><div class="radio nm"><label><input type="radio" name="view" value="D" data-bind="checked:_info.view"  style="margin-top: 2px;"/><?php echo lang('DETAILS'); ?></label></div></td>
										</tr>
										<!-- ko if:_info.report_code()=="I" -->
										<tr>
											<td  class="npt"><div class="radio nm"><label><input type="radio" name="view" value="A" data-bind="checked:_info.view"  style="margin-top: 2px;"/><?php echo lang('AGING'); ?></label></div></td>
										</tr>
										<tr>
											<td  class="npt"><div class="radio nm"><label><input type="radio" name="view" value="O" data-bind="checked:_info.view"  style="margin-top: 2px;"/><?php echo lang('OUTSTANDING'); ?></label></div></td>
										</tr>
										<tr>
											<td  class="npt"><div class="radio nm"><label><input type="radio" name="view" value="U" data-bind="checked:_info.view"  style="margin-top: 2px;"/><?php echo lang('UNINVOICED'); ?></label></div></td>
										</tr>
										<!-- /ko -->
									</tbody>
								</table>
							</div>
						</div>
						<div class="accordion-group">
							<div class="accordion-heading">
								<h3><?php echo lang('COLUMNS'); ?></h3>
							</div>
							<div class="accordion-body">
								<table class="table table-collapsed borderless">
									<tbody>
										<!-- ko if:($root._info.report_code()=="I" && $root._info.view()=="A") -->
										<tr>
											<td><input type="radio" name="interval" value="7" data-bind="checked:_info.interval" ><?php echo lang('7DAY_INTERVAL'); ?></td>
										</tr>
										<tr>
											<td><input type="radio" name="interval" value="15" data-bind="checked:_info.interval"><?php echo lang('15DAY_INTERVAL'); ?></td>
										</tr>
										<tr>
											<td><input type="radio" name="interval" value="30" data-bind="checked:_info.interval" ><?php echo lang('30DAY_INTERVAL'); ?></td>
										</tr>
										<!-- /ko -->
										<!-- ko ifnot:($root._info.report_code()=="I" && $root._info.view()=="A") -->
										<!-- ko foreach:columns -->
										<tr data-bind="visible:left_col_visible">
											<td class="npt">
												<div class="checkbox nm"><label><input type="checkbox" data-bind="value:name, checked:enabled, disable:($root._info.group_by()==name)" style="margin-top: 2px;"/><!-- ko text:label --><!-- /ko --></label></div>
											</td>
										</tr>
										<!-- /ko -->
										<!-- /ko -->
									</tbody>
								</table>
							</div>
						</div>
					</div>
				</div>
			</div>
			<div class="col-md-12" data-bind="css:{'col-md-9':isPinned, 'col-md-12':!isPinned()}">
				<div class="row">
					<div class="col-md-12">
						<div class="">
							<ul class="nav nav-tabs">
								<li data-bind="css:{'active':_info.report_code()=='T'}, click:changeReport('T')">
									<a href="javascript:;"><?php echo lang('TIME'); ?></a>
								</li>
								<li data-bind="css:{'active':_info.report_code()=='A'}, click:changeReport('A')">
									<a href="javascript:;"><?php echo lang('TASK'); ?></a>
								</li>
								<?php if (is_admin()): ?>
								<li data-bind="css:{'active':_info.report_code()=='I'}, click:changeReport('I')">
									<a href="javascript:;"><?php echo lang('INVOICE'); ?></a>
								</li>
								<li data-bind="css:{'active':_info.report_code()=='BU'}, click:changeReport('BU')">
									<a href="javascript:;"><?php echo lang('BUDGET'); ?></a>
								</li>
								<?php endif; ?>
								<li data-bind="css:{'active':_info.report_code()=='E'}, click:changeReport('E')">
									<a href="javascript:;"><?php echo lang('EXPENSES'); ?></a>
								</li>
							</ul>
						</div>
						<div class="clearfix">&nbsp;</div>
						<div class="row nm">
							<div class="col-md-3">
								<h3 class="nm" data-bind="text:report_title"></h3>
							</div>
							<div class="col-md-8 btn-group btn-toggle" data-bind="visible:_info.report_code()=='BU'"> 
								<button data-bind="click:swap_btype, css:{'btn-primary active': _info.budget_type()=='H'}" class="btn btn-sm  btn-default">Hour</button>
								<button data-bind="click:swap_btype, css:{'btn-primary active': _info.budget_type()!='H'}" class="btn btn-sm  btn-default">Amount</button>
							</div>
							<!-- ko foreach:_info.filter_label -->
								<div class="col-md-4">
									<h3 class="nm title gray"><!-- ko text: $data --><!-- /ko --></h3>
								</div>
							<!-- /ko -->
							<!-- ko if:(_info.report_code()=="U" && _info.view()=="O") || (_info.report_code()=="U" && _info.view()=="E") -->
								<div class="col-md-3">
									<input type="button" name="back" value="Summary" data-bind="click:function(){show_summary('I', 'U');}" class="btn btn-default" />
								</div>
							<!-- /ko -->
							<!-- ko ifnot:(_info.report_code()=="I" && _info.view()=="A") || (_info.report_code()=="I" && _info.view()=="O") || _info.report_code()=='U' || _info.report_code()=="BU" || _info.report_code()=="BD" -->
							<div class="dropdown pr dib pull-right" style="margin:5px 0 0 20px;">
								<div class="dib pr vam">
									<span class="cp badge small" data-bind="click:function(){date_filter.is_dft(!date_filter.is_dft());}">
										<!-- ko text:_info.date_filter_disp --><!-- /ko --> <i class="icon-chevron-down icon-white" style="margin-left:10px;">&nbsp;</i>
									</span>
									<div class="dropdown-menu dtFilter" data-bind="css:{'active':date_filter.is_dft}" style="width:330px;left:-50px;">
										<ul class="dropdown-menu pull-left list-unstyled">
											<?php
												foreach ($date_filter_this as $key=>$val)
												{
													echo '<li class="" data-bind="click:function(){date_filter.applyDFT(\'' . $key . '\')}"><a href="javascript:;">' . lang($val) . '</a></li>';
												}
											?>
										</ul>
										<ul class="dropdown-menu pull-left list-unstyled">
											<?php
												foreach ($date_filter_last as $key=>$val)
												{
													echo '<li class="" data-bind="click:function(){date_filter.applyDFT(\'' . $key . '\')}"><a href="javascript:;">' . lang($val) . '</a></li>';
												}
											?>
										</ul>
										<ul class="custom pull-left list-unstyled" data-bind="with:date_filter">
											<li style="margin-top: 2px;"><?php echo lang("CUSTOM")?></li>
											<li style="margin: 0px 3px;">
												<div class="pull-left pr">
													<h5 class="pull-left nm" style="padding:4px 6px; border:1px solid #CCC; font-weight:normal;" data-bind="text:fd_disp"></h5>
													<input type="text" class="dtpicker" data-bind="value:from_date, datepicker:true" />
												</div>
											</li>
											<li style="margin-top: 2px;"><?php echo "-";//lang("TO"); ?></li>
											<li style="margin: 0px 3px;">
												<div class="pull-left pr">
													<h5 class="pull-left nm" style="padding:4px 6px; border:1px solid #CCC; font-weight:normal;" data-bind="text:td_disp"></h5>
													<input type="text" class="dtpicker" data-bind="value:to_date, datepicker:true" />
												</div>
											</li>
											<li style="margin-top: 2px;">
												<button type="button" data-bind="click:fd_td_apply" class="btn btn-xs btn-success"><?php echo lang('APPLY'); ?></button>
											</li>
										</ul>
									</div>
								</div>
								<div class="dib pr vam">
									<div class="pull-left pr">
										<h4 class="pull-left no-margin" style="padding:4px 6px;" data-bind="text:date_disp"></h4>
										<input type="text" id="date-picker" class="fw dib dtpicker np nm nb fh cp" data-bind="value:date, datepicker:true" />
									</div>
									<div class="pull-left">
										<button data-bind="click:dateUpDown.bind($data, '+')" class="btn no-bg nb np split icon-chevron-up up" type="button"></button>
										<button data-bind="click:dateUpDown.bind($data, '-')" class="btn no-bg nb np split icon-chevron-down" type="button"></button>
									</div>
								</div>
							</div>
							<!-- /ko -->
						</div>		
						<div data-bind="foreach:_info.app_filters" class="col-md-12 gray" style="padding-top:5px;">							
							<!-- ko if:$index() == 0 -->
								<i style="font-size:16px;padding-right:4px" class="icon-filter gray"></i>
							<!-- /ko -->
							<span data-bind="text:label,log:$parent._info.app_filters().length"></span>
							<!-- ko if:$index() + 1 < $parent._info.app_filters().length -->
									<span>&nbsp;-&nbsp;</span>
							<!-- /ko -->
						</div>
						<div data-bind="foreach:_info.filters_history()[_info.report_code()]" class="col-md-12" style="padding-top:5px;">
							<!-- ko if:$index() <= 0 -->
								<i class="icon-home" data-bind="click:$parent.root_back" style="font-size:16px;padding-right:4px;cursor:pointer"></i>
							<!-- /ko -->
							<!-- ko if:$index() >= 0 -->
								&nbsp;&nbsp;>>&nbsp;&nbsp;									
								<!-- ko if:$index() + 1 == $parent._info.filters_history()[$parent._info.report_code()].length -->
									<span data-bind="text:$data.key"></span>
								<!-- /ko -->
								<!-- ko if:$index() + 1 != $parent._info.filters_history()[$parent._info.report_code()].length -->
									<span data-bind="text:$data.key,click:function(item,elem) {$parent.back(item,false)}" class="text-primary cp"></span>
								<!-- /ko -->
							<!-- /ko -->												
						</div>
						<div class="row nm" data-bind="visible:_info.report_code()=='E'">
							<div class="col-md-12">
								<div class="row">
									<h4 class="col-xs-4  col-md-4 text-center" data-bind="visible:_expense.approved() >=0 "><small><?php echo lang('APPROVED')?></small><div  data-bind="html:Otime.Currency+ ' '+ _expense.approved().toFixed(2)" ></div></h4>
									<h4 class="col-xs-4  col-md-4 text-center" data-bind="visible:_expense.unapproved() >=0 "><small><?php echo lang('UNAPPROVED')?></small>&nbsp;<div  data-bind="html:Otime.Currency+ ' '+ _expense.unapproved().toFixed(2)" ></div></h4>
									<h4 class="col-xs-4  col-md-4 text-center"><small><?php echo lang('TOTAL')?></small>&nbsp;<div  data-bind="html:Otime.Currency+ ' '+ _expense.total().toFixed(2)" ></div></h4>
								</div>
							</div>
						</div>
						<div class="row nm" data-bind="visible:show_chart()">
						<!--  <div class="col-md-12" data-bind="css:{'col-md-9':isPinned, 'col-md-12':!isPinned()}"> -->
							<div class="col-md-12">
							<!-- ko if:lineChart().length>0 -->
								<div class="col-md-12" style="width:100%; height:200px;position:relative; display:block;" data-bind="line:{labels:labels(), data:lineChart(), colors:['#008B8B', '#F4A460'], legend:false, tooltip:true}"></div>
							<!-- /ko -->
							<!-- ko if:stackedBar().length>0 -->
								<div class="row" data-bind="visible:_time.show_totals">
									<h4 class="col-xs-3  col-md-3 text-center"><small class="bill" ><?php echo lang('BILLABLE')?></small><div  data-bind="text:_time.billable().toFixed(2)+ ' Hrs'" ></div></h4>
									<h4 class="col-xs-3  col-md-3 text-center"><small class="nonbill" ><?php echo lang('NON_BILLABLE')?></small>&nbsp;<div  data-bind="text:_time.non_billable().toFixed(2)+ ' Hrs'" ></div></h4>
									<?php if (is_admin()) { ?>
										<h4 class="col-xs-3  col-md-3 text-center"><small><?php echo lang('INVOICED')?></small><div  data-bind="text:_time.invoiced().toFixed(2)+ ' Hrs'" ></div></h4>
										<h4 class="col-xs-3  col-md-3 text-center"><small><?php echo lang('UN_INVOICED')?></small>&nbsp;<div  data-bind="text:_time.un_invoiced().toFixed(2)+ ' Hrs'" ></div></h4>
									<?php } ?>
								</div>
								<span class="clearfix"></span>
								<!-- ko if:_info.report_code()=='I' -->
								<div class="col-xs-12  col-md-12" style="height:200px;position:relative; display:block;" data-bind="visible:show_chart, stackedBar:{data:stackedBar(), ticks:ticks(), colors:colors(), legend:false, tooltip:true, stack:stack, tooltip_lprefix:Otime.Currency}"></div>
								<!-- /ko -->
								<!-- ko if:(_info.report_code()!='E' && _info.report_code()!='I')-->
									<!-- ko if:(_info.report_code()=='T' && _info.group_by()=='DA')-->
										<div class="col-xs-12  col-md-12" style="height:200px;position:relative; display:block;" data-bind="visible:show_chart, stackedBar:{data:stackedBar(), ticks:ticks(), colors:colors(), legend:false, tooltip:true, stack:stack, tooltip_lsuffix:' hrs', tooltip_params:tooltip_params()}"></div>
									<!-- /ko -->
									<!-- ko ifnot:(_info.report_code()=='T' && _info.group_by()=='DA')-->
										<!-- ko if:(_info.report_code()=="A" && _info.view()=="S") -->
											<div class="col-xs-12  col-md-12" style="height:200px;position:relative; display:block;" data-bind="visible:show_chart, stackedBar:{data:stackedBar(), ticks:ticks(), colors:colors(), legend:false, tooltip:true, stack:stack, tooltip_lsuffix:' %'}"></div>
										<!-- /ko -->
										<!-- ko ifnot:(_info.report_code()=="A" && _info.view()=="S") -->
											<div class="col-xs-12  col-md-12" style="height:200px;position:relative; display:block;" data-bind="visible:show_chart, stackedBar:{data:stackedBar(), ticks:ticks(), colors:colors(), legend:false, tooltip:true, stack:stack, tooltip_lsuffix:' hrs'}"></div>
										<!-- /ko -->
									<!-- /ko -->
								<!-- /ko -->
								
							<!-- /ko -->
							<!-- ko if:(multiBar().length>0 && (_info.report_code()=='BU' || _info.report_code()=='E')) -->
								<div class="col-xs-12  col-md-12" style="height:200px;position:relative; display:block;" data-bind="visible:show_chart, multiBar:{data:multiBar(), ticks:ticks(), colors:colors(), legend:false, tooltip:true, tooltip_lprefix:Otime.Currency}"></div>
							<!-- /ko -->
							</div>
						</div>
					</div>
					<div class="clearfix">&nbsp;</div>
					<div id="list_grid" class="col-md-12 table-responsive" data-bind="css:{'col-lg-11': (view_hours_mode()==true || view_expense_mode()==true)}">
						<table class="report-table table table-hover" id="report-list-table" cellspacing="0" cellpadding="0" border="0">
						</table>
						<!-- ko if:(_info.report_code()=="I" && _info.view()=="U") -->
							<!-- ko if:listing().length>0 -->
								<input type="button" name="invoice" value="Invoice" data-bind="click:showInvoice" class="btn btn-default" />
							<!-- /ko -->	
						<!-- /ko -->
						<div data-bind="visible:listing().length==0" class="text-center" style="padding-top:10px">
							<span class="well" data-bind="visible:loading() != false"><?php echo lang('LOADING'); ?></span>
							<span class="well" data-bind="visible:loading() == false"><?php echo lang('NO_DATA_FOUND'); ?></span>
						</div>
					</div>
					<div class="page-slide col-lg-4 col-md-6 auto-height"  data-bind="slideVisible:view_hours_mode()==true">
						<div class="panel sidebar-fixed-header panel-primary">
							<div class="panel-heading">
								<h3 class="panel-title with-btn"><?php echo lang('UNAPPROVED_HOURS'); ?></h3>
								<div class="pull-right">
									<button class="btn btn-sm btn-danger" id="cancel" data-bind="click:hours_close">
										<?php echo lang('CLOSE'); ?>
									</button>
								</div>
							</div>
							<div class="panel-body">
								<div id="view_approve_hours">
								</div>
							</div>
						</div>
					</div>
					<div class="page-slide col-lg-4 col-md-6 auto-height"  data-bind="slideVisible:view_expense_mode()==true">
						<div class="panel sidebar-fixed-header panel-primary">
							<div class="panel-heading">
								<h3 class="panel-title with-btn"><?php echo lang('UNAPPROVED_EXPENSES'); ?></h3>
								<div class="pull-right">
									<button class="btn btn-sm btn-danger" id="cancel" data-bind="click:expense_close">
										<?php echo lang('CLOSE'); ?>
									</button>
								</div>
							</div>
							<div class="panel-body">
								<div id="view_approve_expenses">
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
<div id="tableTmpl" style="display:none;">
</div>
<div id="lstTmpl" style="display:none;">
</div>
<div id="lstDetailTmpl" style="display:none;">
</div>
<script id="totalTmpl" type="text/html">
	<tr class="tbdy text-center" data-bind="foreach:{data:$root.columns, as:'column'}">
	<!-- ko if:column.visible && column.left_col_visible && column.type != 'AL' -->
		<td>
			<h4><span class="label label-default" data-bind="text:item[column.name]"></span></h4>
		</td>
	<!-- /ko -->
	</tr>
</script>
<?php
	if (!$is_ajax_request)
	{
		$this->load->view("footer");
	}

	$jslang	= array();
	
	$tmp	= array(
		'REPORT_T_TITLE',
		'REPORT_TS_TITLE',
		'REPORT_TD_TITLE',
		'REPORT_TK_TITLE',
		'REPORT_I_TITLE',
		'REPORT_IS_TITLE',
		'REPORT_ID_TITLE',
		'REPORT_IA_TITLE',
		'REPORT_IO_TITLE',
		'REPORT_IU_TITLE',
		'REPORT_UO_TITLE',
		'REPORT_UE_TITLE',
		'REPORT_BU_TITLE',
		'REPORT_BD_TITLE',
		'REPORT_E_TITLE',
		'REPORT_ES_TITLE',
		'REPORT_ED_TITLE',
		'REPORT_AGING_DETAIL_TITLE',
		'TODAY',
		'THIS_WEEK',
		'THIS_SEMI_MONTHLY',
		'THIS_MONTH',
		'THIS_QUARTER',
		'THIS_YEAR',
		'THIS_ACCOUNT_YEAR',
		'YESTERDAY',
		'LAST_WEEK',
		'LAST_SEMI_MONTHLY',
		'LAST_MONTH',
		'LAST_QUARTER',
		'LAST_YEAR',
		'LAST_ACCOUNT_YEAR'
	);
	foreach ($tmp as $val)
	{
		$jslang[$val]	= lang($val);
	}
?>
<script type="text/javascript">
	$(document).ready(function(){
		Otime.Report.language	= <?php echo json_encode($jslang); ?>;
		Otime.Report.Currency	= <?php echo json_encode($currency); ?>;
		Otime.Report.filter_labels	= <?php echo json_encode(array_merge($date_filter_this, $date_filter_last)); ?>;
		Otime.Report.page	= '<?php echo $type; ?>';
		Otime.Report.view	= 'S';
		Otime.Report.dft	= 'TM'; // Date filter type
		Otime.Report.status = <?php echo json_encode(array('d'=>'Draft', 's'=>'Sent', 'p'=>'Paid', 'b'=>'Partial')); ?>;
		Otime.Report.status_class	= <?php echo json_encode($this->config->item('status_class')); ?>;
		Otime.Report.Bookmark.data	= <?php echo $bookmarks; ?>;
		window.Otime.load("Report");
	});
</script>
<div class="modal" id="hours_approve" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
	<div class="modal-dialog">
		<div class="modal-content">
			<div class="modal-header">
				<button type="button" class="close" aria-hidden="true" data-bind="click:popup_close">&times;</button>
				<h4 class="modal-title" id="myModalLabel"><?php echo lang('MODAL_TITLE'); ?></h4>
			</div>
			<div class="modal-body"></div>
		</div>
	</div>
</div>
<div class="modal" id="expenses_approve" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
	<div class="modal-dialog">
		<div class="modal-content">
			<div class="modal-header">
				<button type="button" class="close" aria-hidden="true" data-bind="click:popup_close">&times;</button>
				<h4 class="modal-title" id="myModalLabel"><?php echo lang('MODAL_TITLE'); ?></h4>
			</div>
			<div class="modal-body"></div>
		</div>
	</div>
</div>
<iframe style="display:none" id="iframe_download" src="about:blank" target="_blank"></iframe>
