(function(Otime){

	Otime.BookMark	= new function BookMark(){
//		"use strict";

		var _this	= this;

		_this.name	= "bookmark";

		_this.model	= "BMListModel";

		_this.language	= null;
		
		_this.base_url = null;

		_this.current_view	= "";

		_this.BMListModel	= function(data){
			var self	= this;

			data	= data || {};

			self.items	= Otime.a([]);

			self.newItem	= Otime.o(new _this.BMContentModel({
				type: data.type || ""
			}));
			self.selectedItem	= Otime.o(null);

			self.is_edit_mode	= Otime.o(false);

			self.other_page	= Otime.o(Otime.app.currentViewName != "Report");

			if (data.items && data.items.otvalues && data.items.otvalues.length > 0)
			{
				var tmpList	= [];
				data.items	= data.items.otvalues.setKeys(data.items.otkeys, function(item){
					tmpList.push(new _this.BMContentModel(item));
				});
				self.items(tmpList);
			}

			self.remove	= function(item, elem){
				$.get(Otime.baseUrl+"index.php/bookmarks/delete/" + item.id(), null, function(response){
					if(response[0])
					{
						self.items.remove(item);
					}
				});
				
			};

			self.addNew	= function(){
				self.is_edit_mode(true);
				$('#new_bkmark').focus();
			};

			self.onKeyPress	= function(item, e){
				if (e && e.keyCode)
				{
					switch(e.keyCode)
					{
						case 13:	// Enter
							self.save(item);
							return false;
							break;
						case 27:	// Esc
							self.cancel(item);
							return false;
							break;
					}
				}
				return true;
			};

			var clearValues	= function(item){
				item.id(0);
				item.name("");
				item.type(data.type || "");
				item.filters("");
				item.url("");
			};

			self.save	= function(item, elem){
				if (_this.current_view.Bookmark.get)
				{
					item.filters(_this.current_view.Bookmark.get() || {});
				}
				else
				{
					return false;
				}
				item.url(Otime.Menu.State.hash);

				var saveData	= JSON.parse(ko.toJSON(item));
				saveData.filters	= JSON.stringify(saveData.filters);

				$.ajax({
					type: "POST",
					url: Otime.baseUrl + "index.php/bookmarks/save",
					data: saveData,
					dataType: "JSON",
					global: false,
					success: function(response){
						_this.model(new _this.BMListModel(response[2]));
						clearValues(item);
						self.is_edit_mode(false);
						_this.container.show();
/*
						saveData.id	= response[2].id;
						self.items.push(new _this.BMContentModel(saveData));
						clearValues(item);
						self.is_edit_mode(false);
						_this.container.show();
*/
					}
				});
			};

			self.cancel	= function(item){
				clearValues(item);
				self.is_edit_mode(false);
				_this.container.toggle();
			};

			self.applyThis	= function(item, elem){
//				$("#bkmark-list li").removeClass("active");
//				$(elem.delegateTarget).parent().addClass("active");
				self.selectedItem(item);
				if (item.url().replace(/\/$/g, "").replace("/index.php", "index.php") == Otime.Menu.State.hash.replace(/\/$/g, "").replace("/index.php", "index.php"))
				{
					_this.current_view.Bookmark.set(JSON.parse(item.filters()));
				}
				else
				{
					var url	= (Otime.baseUrl + item.url().replace("/index.php", "index.php"));
					Otime.Menu._load_page(url, true, {
						bk: item.id()
					});
				}
				_this.container.hide();
			};
		};

		_this.BMContentModel	= function(data){
			var self	= this;

			data	= data || {};

			self.id			= Otime.o(data.id || 0);
			self.name		= Otime.o(data.name || "");
			self.type		= Otime.o(data.type || "");
			self.filters	= Otime.o(data.filters || "");
			self.url		= Otime.o(data.url || "");

			return self;
		};

		_this.model	= Otime.o(null);

		_this.init	= function(){
			_this.container	= $("#bookmark-container");

			if (_this.container.is(":visible"))
			{
				_this.container.hide();
			}
			else
			{
				if (ko.dataFor(_this.container.get(0)) == undefined)
				{
					_this.model(new _this.BMListModel());
					ko.applyBindings(_this.model, _this.container.get(0));
				}

				$.ajax({
					type: "POST",
					url: Otime.baseUrl+"index.php/bookmarks/listing",
					data: null,
					global: false,
					dataType: "JSON",
					success: function(resp){
						_this.model(new _this.BMListModel(resp[2]));
						_this.container.show();
						return;
					}
				});
			}
		};

	};

}(window.Otime));
